<template>
  <div :class="$style.pagination">
    <div :class="$style.prev" @click="prev()"><PaginationArrow /></div>
    <ul :class="$style.pageList">
      <li
        v-for="page in pages"
        :key="page.number"
        :class="$style[page.isActive ? 'active' : '']"
        @click="setPage(page.number)"
      >
        {{ page.number }}
      </li>
    </ul>
    <div :class="$style.next" @click="next()"><PaginationArrow /></div>
  </div>
</template>

<script>
import PaginationArrow from "@/assets/images/icons/pagination-arrow.svg";

export default {
  name: "Pagination",
  components: { PaginationArrow },
  props: {
    itemsCount: {
      type: Number,
      default: 1
    },
    itemsOnPage: {
      type: Number,
      default: 4
    },
    maxShowingPages: {
      type: Number,
      default: 10
    },
    currentPage: {
      type: Number,
      default: 0
    }
  },
  computed: {
    totalPages() {
      return Math.ceil(this.itemsCount / this.itemsOnPage);
    },
    pages() {
      const showingPages =
        this.maxShowingPages < this.totalPages
          ? this.maxShowingPages
          : this.totalPages;
      const maxMargin = this.totalPages - showingPages;
      let margin = this.currentPage - this.maxShowingPages / 2;
      margin = margin < 0 && showingPages <= this.maxShowingPages ? 0 : margin;
      margin = margin > maxMargin ? maxMargin : margin;

      const pages = [...Array(showingPages).keys()].map(key => {
        const number = key + margin + 1;

        return {
          number,
          isActive: number === this.currentPage
        };
      });

      return pages;
    }
  },
  methods: {
    setPage(page) {
      this.$emit("on-page-change", page);
    },
    next() {
      const next = this.currentPage + 1;
      if (next <= this.totalPages) {
        this.setPage(next);
      }
    },
    prev() {
      const prev = this.currentPage - 1;
      if (prev > 0) {
        this.setPage(prev);
      }
    }
  }
};
</script>

<style lang="scss" module>
@import "../../shared/styles/imports.scss";

@mixin paginationBtn {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 36px;
  min-width: 20px;
  padding: 0 5px;
  border: 1px solid #ccc;
  cursor: pointer;

  &:hover {
    background-color: $mainBgColor;
  }
}

.pagination {
  display: flex;
}

.pageList {
  @include clearUl();

  display: flex;

  li {
    @include paginationBtn;

    font-size: 15px;
    line-height: 20px;
    border-right: none;

    &.active {
      color: white;
      background-color: #848e8e;
    }
  }
}

.next,
.prev {
  @include paginationBtn;
}

.prev {
  border-right: none;
  border-radius: 4px 0px 0px 4px;
}

.next {
  border-radius: 0px 4px 4px 0px;

  & > * {
    transform: rotate(180deg);
  }
}
</style>
